#!/usr/bin/env python
import sys, getopt, collections

# # Viterbi ## use global prob matrix tagtoword
def Viterbi(observation,tagtransgraph,starttaggraph):
  globaltags = {'ADV':1,'NOUN':2,'ADP':3,'.':4,'PRON':5,'VERB':6,'X':7,'CONJ':8,'ADJ':9}
  lenglobaltags = len(globaltags)
  lenobservation = len(observation)
  lentagtransgraph = len(tagtransgraph)
  viterbimatrix = [[None for _ in range(lenobservation)] for _ in range(lenglobaltags+2)]
  backpointer = [[None for _ in range(lenobservation)] for _ in range(lenglobaltags+2)]
  for i,state in enumerate(globaltags):
    viterbimatrix[globaltags[state]][0] = starttaggraph[('START',state)]*tagtoword[(state,observation[0])]
    backpointer[globaltags[state]][0] = 0
  for i in range(lenobservation-1):
    for j,state in enumerate(globaltags):
      #print viterbimatrix
      viterbimatrix[globaltags[state]][i+1] = max([viterbimatrix[globaltags[s]][i]*tagtransgraph[(s,state)]*tagtoword[(state,observation[i+1])] for s in globaltags])
      argmaxS = 'NONE'
      maxS = 0
      for s in globaltags:
        newmax = viterbimatrix[globaltags[s]][i]*tagtransgraph[(s,state)]
        if newmax>maxS:
          maxS = newmax
          argmaxS = s
      backpointer[globaltags[state]][i+1] = argmaxS
  #viterbimatrix[lenglobaltags+1][lenobservation] = max([viterbimatrix[globaltags[s]][lenobservation]* for s in globaltags])
  argmaxGlobal = 'NONE'
  maxGlobal = 0
  for i in globaltags:
    if viterbimatrix[globaltags[i]][lenobservation-1] > maxGlobal:
      maxGlobal = viterbimatrix[globaltags[i]][lenobservation-1]
      argmaxGlobal = i
  # # get tag path
  tagpath = []
  tagpath.append(argmaxGlobal)
  for i in range(lenobservation-1):
    #print argmaxGlobal
    tagpath.append(backpointer[globaltags[argmaxGlobal]][lenobservation-i-1])
    argmaxGlobal = backpointer[globaltags[argmaxGlobal]][lenobservation-i-1]
  print viterbimatrix
  print tagpath
  return reversed(tagpath)

##################################################################

# # 10-fold validation
def splitsentence(filename):
  sentencearray = []
  for line in open(str(filename)):
    sentencearray.append(linefactory(line))
  return sentencearray

def linefactory(line):
  wordlist = []
  taglist = [x.rsplit('/',1) for x in str(line).split()]
  for item in taglist:
    wordlist.append(item[0])
  return wordlist

# # positions are in range [0-1,9-10]
def splitarray(position1,position2,testarray):
  lenarray = len(testarray)
  listfortest = testarray[position1*lenarray/10:position2*lenarray/10]
  return listfortest

# # get training data
def trainlinefactory(line):
  trainlist = []
  taglist = [x.rsplit('/',1) for x in str(line).split()]
  for item in taglist:
    wordlist.append(item[0])
  return wordlist

###################################################################

train_file=""
test_file=""
readable = False
try:
  opts, args = getopt.getopt(sys.argv[1:], "h", ["help", "readable", "train=", "test="])
except getopt.GetoptError:
  print "Usage: example.py [--readable]"
  sys.exit(2)
for opt, arg in opts:
  if opt in ("-h", "--help"):
    print "Usage: example.py [--readable]"
    sys.exit()
  elif opt in ("--readable"):                
    readable = True                 
  elif opt in ("--train"):                
    train_file = arg 
  elif opt in ("--test"):                
    test_file = arg 

# Collect counts of (token,tag) pairs
# tags = collections.defaultdict(int)
# token_tag_count = collections.defaultdict(int)
# for line in open(train_file):
#   for token,tag in [x.rsplit('/',1) for x in line.split()]:
#     token_tag_count[(token,tag)] += 1
#     tags[tag] += 1

# print tags
# print len(tags)

# # Transition of tags by pairs
transtotal = 0
linecount = 0
transtag = collections.defaultdict(int)
starttag = collections.defaultdict(int)
starttagprob = collections.defaultdict(float)
transtagprob = collections.defaultdict(float)

for line in open(train_file):
  taglist = [x.rsplit('/',1) for x in line.split()]
  starttag[('START',taglist[0][1])]+=1
  linecount+=1
  taglen = len(taglist)
  for index,tagpair in enumerate(taglist):
    if index<taglen-1:
      nexttag = taglist[index+1]
      transtag[(tagpair[1],nexttag[1])]+=1
      transtotal+=1

# # Add-one smoothing
typelendivisor = len(transtag)+transtotal
starttagdivisor = len(starttag)+linecount

# # get probability
for item in transtag:
  transtagprob[item]=(transtag[item]+1.0)/typelendivisor
for item in starttag:
  starttagprob[item]=(starttag[item]+1.0)/starttagdivisor

#print transtagprob
# print len(transtagprob)

# # tag to words
countword = 0
tagtoword = collections.defaultdict(float)
tagworddict = collections.defaultdict(int)
for line in open(train_file):
  for token,tag in [x.rsplit('/',1) for x in line.split()]:
    tagtoword[(tag,token)]+=1
    tagworddict[tag]+=1
    countword+=1
for item in tagtoword:
  tagtoword[item]=tagtoword[item]*1.0/tagworddict[item[0]]

path = Viterbi(['Formanden','for','ETAGEBO','Jan','.'],transtagprob,starttagprob)
print path

# testarray = splitsentence(train_file)
# splitarray(1,2,testarray)
# print len(testarray)

# print len(tagworddict)
#print tagworddict
# print tagtoword

# # find the most frequent tag
# global_max_tag = None
# global_max_tag_frequency = 0
# for tag in tags:
#   if tags[tag] > global_max_tag_frequency:
#     global_max_tag_frequency = tags[tag]
#     global_max_tag = tag

# # Output the most frequent tag for each test word. 
# # If the word is unknown, output the most frequent tag
# if not readable: print "Tag" # Kaggle expects a header line
# for line in open(test_file):
#   for token in line.split():
#     max_tag = None
#     max_tag_frequency = 0
#     for tag in tags:
#       if token_tag_count[(token,tag)] > max_tag_frequency:
#         max_tag_frequency = token_tag_count[(token,tag)]
#         max_tag = tag
#     if max_tag == None:
#       max_tag = global_max_tag
#     if readable:
#       print "%s/%s" % (token,max_tag),
#     else:
#       print max_tag
#   if readable:
#     print
